import { jsx, Fragment } from 'react/jsx-runtime';
import { datadogRum } from '@datadog/browser-rum';
import { useEffect } from 'react';

var DEFAULT_SAMPLE_RATE = 100;

var FIRST_ITEM = 0;
function useDataDog(_a) {
    var actionNameAttribute = _a.actionNameAttribute, allowedTracingOrigins = _a.allowedTracingOrigins, applicationId = _a.applicationId, beforeSend = _a.beforeSend, clientToken = _a.clientToken, defaultPrivacyLevel = _a.defaultPrivacyLevel, enableExperimentalFeatures = _a.enableExperimentalFeatures, _b = _a.enabled, enabled = _b === void 0 ? true : _b, env = _a.env, intakeApiVersion = _a.intakeApiVersion, internalMonitoringApiKey = _a.internalMonitoringApiKey, proxyUrl = _a.proxyUrl, replaySampleRate = _a.replaySampleRate, replica = _a.replica, _c = _a.sampleRate, sampleRate = _c === void 0 ? DEFAULT_SAMPLE_RATE : _c, service = _a.service, _d = _a.sessionReplayRecording, sessionReplayRecording = _d === void 0 ? true : _d, silentMultipleInit = _a.silentMultipleInit, _e = _a.site, site = _e === void 0 ? 'datadoghq.com' : _e, _f = _a.trackInteractions, trackInteractions = _f === void 0 ? true : _f, trackSessionAcrossSubdomains = _a.trackSessionAcrossSubdomains, trackViewsManually = _a.trackViewsManually, useAlternateIntakeDomains = _a.useAlternateIntakeDomains, useCrossSiteSessionCookie = _a.useCrossSiteSessionCookie, useSecureSessionCookie = _a.useSecureSessionCookie, version = _a.version;
    useEffect(function () {
        if (!enabled) {
            return;
        }
        datadogRum.init({
            actionNameAttribute: actionNameAttribute,
            allowedTracingOrigins: allowedTracingOrigins === null || allowedTracingOrigins === void 0 ? void 0 : allowedTracingOrigins.slice(FIRST_ITEM),
            applicationId: applicationId,
            beforeSend: beforeSend,
            clientToken: clientToken,
            defaultPrivacyLevel: defaultPrivacyLevel,
            enableExperimentalFeatures: enableExperimentalFeatures === null || enableExperimentalFeatures === void 0 ? void 0 : enableExperimentalFeatures.slice(FIRST_ITEM),
            env: env,
            intakeApiVersion: intakeApiVersion,
            internalMonitoringApiKey: internalMonitoringApiKey,
            proxyUrl: proxyUrl,
            replaySampleRate: replaySampleRate,
            replica: replica,
            sampleRate: sampleRate,
            service: service,
            silentMultipleInit: silentMultipleInit,
            site: site,
            trackInteractions: trackInteractions,
            trackSessionAcrossSubdomains: trackSessionAcrossSubdomains,
            trackViewsManually: trackViewsManually,
            useAlternateIntakeDomains: useAlternateIntakeDomains,
            useCrossSiteSessionCookie: useCrossSiteSessionCookie,
            useSecureSessionCookie: useSecureSessionCookie,
            version: version,
        });
    }, [
        actionNameAttribute,
        allowedTracingOrigins,
        applicationId,
        beforeSend,
        clientToken,
        defaultPrivacyLevel,
        enableExperimentalFeatures,
        enabled,
        env,
        intakeApiVersion,
        internalMonitoringApiKey,
        proxyUrl,
        replaySampleRate,
        replica,
        sampleRate,
        service,
        silentMultipleInit,
        site,
        trackInteractions,
        trackSessionAcrossSubdomains,
        trackViewsManually,
        useAlternateIntakeDomains,
        useCrossSiteSessionCookie,
        useSecureSessionCookie,
        version,
    ]);
    useEffect(function () {
        if (!enabled || !sessionReplayRecording) {
            return;
        }
        datadogRum.startSessionReplayRecording();
        return function () {
            datadogRum.stopSessionReplayRecording();
        };
    }, [enabled, sessionReplayRecording]);
}

function DataDog(_a) {
    var actionNameAttribute = _a.actionNameAttribute, allowedTracingOrigins = _a.allowedTracingOrigins, applicationId = _a.applicationId, beforeSend = _a.beforeSend, children = _a.children, clientToken = _a.clientToken, defaultPrivacyLevel = _a.defaultPrivacyLevel, enableExperimentalFeatures = _a.enableExperimentalFeatures, enabled = _a.enabled, env = _a.env, intakeApiVersion = _a.intakeApiVersion, internalMonitoringApiKey = _a.internalMonitoringApiKey, proxyUrl = _a.proxyUrl, replaySampleRate = _a.replaySampleRate, replica = _a.replica, sampleRate = _a.sampleRate, service = _a.service, sessionReplayRecording = _a.sessionReplayRecording, silentMultipleInit = _a.silentMultipleInit, site = _a.site, trackInteractions = _a.trackInteractions, trackSessionAcrossSubdomains = _a.trackSessionAcrossSubdomains, trackViewsManually = _a.trackViewsManually, useAlternateIntakeDomains = _a.useAlternateIntakeDomains, useCrossSiteSessionCookie = _a.useCrossSiteSessionCookie, useSecureSessionCookie = _a.useSecureSessionCookie, version = _a.version;
    useDataDog({
        actionNameAttribute: actionNameAttribute,
        allowedTracingOrigins: allowedTracingOrigins,
        applicationId: applicationId,
        beforeSend: beforeSend,
        clientToken: clientToken,
        defaultPrivacyLevel: defaultPrivacyLevel,
        enableExperimentalFeatures: enableExperimentalFeatures,
        enabled: enabled,
        env: env,
        intakeApiVersion: intakeApiVersion,
        internalMonitoringApiKey: internalMonitoringApiKey,
        proxyUrl: proxyUrl,
        replaySampleRate: replaySampleRate,
        replica: replica,
        sampleRate: sampleRate,
        service: service,
        sessionReplayRecording: sessionReplayRecording,
        silentMultipleInit: silentMultipleInit,
        site: site,
        trackInteractions: trackInteractions,
        trackSessionAcrossSubdomains: trackSessionAcrossSubdomains,
        trackViewsManually: trackViewsManually,
        useAlternateIntakeDomains: useAlternateIntakeDomains,
        useCrossSiteSessionCookie: useCrossSiteSessionCookie,
        useSecureSessionCookie: useSecureSessionCookie,
        version: version,
    });
    return jsx(Fragment, { children: children }, void 0);
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function DataDogPrivacy(_a) {
    var children = _a.children, level = _a.level;
    return (jsx("span", __assign({ className: "dd-privacy-" + level, "data-dd-privacy": level }, { children: children }), void 0));
}

function DataDogAllow(_a) {
    var children = _a.children;
    return jsx(DataDogPrivacy, __assign({ level: "allow" }, { children: children }), void 0);
}

function DataDogHidden(_a) {
    var children = _a.children;
    return jsx(DataDogPrivacy, __assign({ level: "hidden" }, { children: children }), void 0);
}

function DataDogMask(_a) {
    var children = _a.children;
    return jsx(DataDogPrivacy, __assign({ level: "mask" }, { children: children }), void 0);
}

function DataDogMaskUserInput(_a) {
    var children = _a.children;
    return jsx(DataDogPrivacy, __assign({ level: "mask-user-input" }, { children: children }), void 0);
}

function useDataDogRum() {
    return datadogRum;
}

export { DataDogAllow, DataDogHidden, DataDogMask, DataDogMaskUserInput, DataDog as default, useDataDogRum };
